searchNodes=[{"doc":"This plug logs the incoming requests. It logs the IP address and has the ability to anonymize the IP address if set in config.","ref":"TimeLog.PreLogPlug.html","title":"TimeLog.PreLogPlug","type":"module"},{"doc":"Call to PreLogPlug that initiates the request logging.","ref":"TimeLog.PreLogPlug.html#call/2","title":"TimeLog.PreLogPlug.call/2","type":"function"},{"doc":"Initiates Response logging and logs the incoming request. Ensures that responses are only logged if the corresponding request was logged as well.","ref":"TimeLog.PreLogPlug.html#initiate_logging/1","title":"TimeLog.PreLogPlug.initiate_logging/1","type":"function"},{"doc":"This plug stops the time a request takes. Also, this module delivers additional useful functionality The plug needs to be called as early in the endpoint.ex as possible, ideally right after the socked received a request. Additionally the get_duration function can be called from everywhere in order to know how long the request took so far. Allows calls to get_ip from other apps too.","ref":"TimeLog.TimePlug.html","title":"TimeLog.TimePlug","type":"module"},{"doc":"Call to TimePlug that initiates the duration measurement and schedules Response logging to take place before sending the response.","ref":"TimeLog.TimePlug.html#call/2","title":"TimeLog.TimePlug.call/2","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#check_sanitize_fields/3","title":"TimeLog.TimePlug.check_sanitize_fields/3","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#check_sanitize_list/2","title":"TimeLog.TimePlug.check_sanitize_list/2","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#from_config/1","title":"TimeLog.TimePlug.from_config/1","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#from_config/2","title":"TimeLog.TimePlug.from_config/2","type":"function"},{"doc":"Get the correlation_id.","ref":"TimeLog.TimePlug.html#get_correlation_id/1","title":"TimeLog.TimePlug.get_correlation_id/1","type":"function"},{"doc":"Returns the time in ms the request took so far. May be called with either a DateTime struct DateTime or with the current conn Plug.Conn . Examples iex&gt; TimeLog.TimePlug . get_duration ( conn ) # Request the duration with a `Plug.Conn` struct 65 iex&gt; start_time = DateTime . utc_now ... ... iex&gt; TimeLog.TimePlug . get_duration ( start_time ) # Request the duration with a `DateTime` struct 65","ref":"TimeLog.TimePlug.html#get_duration/1","title":"TimeLog.TimePlug.get_duration/1","type":"function"},{"doc":"Returns the IP address in a Format fit for logging. If set in config the IP addresses retourned are anonymized by replacing the last digits with 'XXX'. Requests that use internal (e.g. company) Ip addresses can be filtered if set in config( config :time_log, internal_ips: [&quot;127.0.0.1&quot;] ).","ref":"TimeLog.TimePlug.html#get_ip/1","title":"TimeLog.TimePlug.get_ip/1","type":"function"},{"doc":"Log the response including the IP address, correlation_id and headers.","ref":"TimeLog.TimePlug.html#log_response/1","title":"TimeLog.TimePlug.log_response/1","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize/1","title":"TimeLog.TimePlug.sanitize/1","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize_body/1","title":"TimeLog.TimePlug.sanitize_body/1","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize_check/2","title":"TimeLog.TimePlug.sanitize_check/2","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize_query_string/1","title":"TimeLog.TimePlug.sanitize_query_string/1","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize_recursiv/3","title":"TimeLog.TimePlug.sanitize_recursiv/3","type":"function"},{"doc":"","ref":"TimeLog.TimePlug.html#sanitize_value/3","title":"TimeLog.TimePlug.sanitize_value/3","type":"function"},{"doc":"Sets the body to be logged in the conn in the private part for the key :controller_body . The body will be included in the response logs if present. Example In a REST Api function that is called to send the result JSON. The output paramter may be any Map or Struct . defp send_response ( conn , output ) do conn |&gt; TimeLog.TimePlug . set_controller_body ( output ) |&gt; json ( output ) end","ref":"TimeLog.TimePlug.html#set_controller_body/2","title":"TimeLog.TimePlug.set_controller_body/2","type":"function"},{"doc":"Plug to log Phoenix requests and responses with a more accurate time than the custom Phoenix logger","ref":"readme.html","title":"TimeLogPlug","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding time_log to your list of dependencies in mix.exs : def deps do [ { :time_log , &quot;~&gt; 0.1.1&quot; } ] end","ref":"readme.html#installation","title":"TimeLogPlug - Installation","type":"extras"},{"doc":"To use the TimeLogPlug correctly you have to adjust your endpoint.ex . In Phoenix projects &gt;= 1.3 it should be located under lib/&lt;project_name&gt;_web/endpoint.ex : defmodule MyProjectWeb.Endpoint do use Phoenix.Endpoint , otp_app : :my_project socket &quot;/socket&quot; , MyProjectWeb.UserSocket plug TimeLog.TimePlug if code_reloading? do plug Phoenix.CodeReloader end plug Plug.RequestId , http_header : &quot;correlation_id&quot; plug Plug.Logger plug Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Poison plug Plug.MethodOverride plug Plug.Head plug Plug.Session , store : :cookie , key : &quot;duefnkaslndfuefnmsdnfuwefn342n&quot; , signing_salt : &quot;LIwo9Kg1&quot; plug CORSPlug plug MyProject.PrometheusExporter # makes the /metrics URL happen plug MyProject.PipelineInstrumenter # measures pipeline exec times plug TimeLog.PreLogPlug plug MyProjectWeb.Router def init ( _key , config ) do IO . puts &quot;Starting Endpoint... \\n With config \#{ inspect ( config ) } &quot; if config [ :load_from_system_env ] do IO . puts &quot;Loading from system Env ...&quot; port = System . get_env ( &quot;PORT&quot; ) || raise &quot;expected the PORT environment variable to be set&quot; { :ok , Keyword . put ( config , :http , [ :inet6 , port : port ] ) } else IO . puts &quot;Not loading from ENV :ok&quot; { :ok , config } end end end Notice that TimeLog.TimePlug gets called right after the socket receives the incoming request with the line plug TimeLog.TimePlug . In your project add it as early as possible too. This ensures that the response time measurement is as accurate as possible. If you want detailed logging of the incoming request - including an ip check for internal ips (that are used for testing for example) - use the TimeLog.PrelogPlug and include the line plug TimeLog.PreLogPlug right before the Router of your app is called.","ref":"readme.html#usage","title":"TimeLogPlug - Usage","type":"extras"},{"doc":"Within your config you can setup what an internal ip is in terms of your app, what name should be shown if an internal ip requested something or requests to which urls to ignore altogether. You can append your config with: config :time_log , internal_ips : [ &quot;192.168.4.1&quot; , &quot;192.168.4.7&quot; , &quot;127.0.0.1&quot; ] , # The IP&#39;s that identify a request as internal, used for testing purposes for example internal_name : &quot;Internal IP&quot; , # The name that should be logged instead of Internal IP address ignore_urls : [ &quot;/health&quot; ] , # Urls that should not be logged anonymize_ips? : true , # Should ips be anonymized for privacy of customer data? sanitize_string : &quot;*&quot; , # String which replaces values of sanitized fields wildcard_string : &quot;*&quot; , # Wildcard string which can be used for sanitize fields e.g. &quot;map.*&quot; =&gt; sanitize all field values in &quot;map&quot; sanitize_fields : [ &quot;*.map.*&quot; , &quot;anotherMap.field&quot; , &quot;list.*.field&quot; ] # &quot;*.map.*&quot; =&gt; searchs for field &quot;map&quot; in any level and sanitize all field values underneath. &quot;anotherMap.field&quot; searchs field &quot;anotherMap&quot; in first level and sanitize only value of &quot;field&quot;. If &quot;field&quot; is a map or list, use &quot;anotherMap.field.*&quot; otherwise it won&#39;t sanitize any field in that map or list. &quot;list.*.field&quot; the wildcard &quot;*&quot; between &quot;list&quot; and &quot;field&quot; means that it will firstly search for list in first level, secondly it will search for &quot;field&quot; in any level under &quot;list&quot; and sanitize it. If the wildcard is infront of a field it will ignore the level of the structure, if it&#39;s behind a field e.g. &quot;map.*&quot; it will sanitize all fields under that structure. The docs can be found at https://hexdocs.pm/time_log .","ref":"readme.html#config","title":"TimeLogPlug - Config","type":"extras"}]